/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.community.enterprise.wrapper;

import org.springblade.community.agency.entity.Agency;
import org.springblade.community.agency.service.IAgencyService;
import org.springblade.community.residential.entity.Residential;
import org.springblade.community.residential.service.IResidentialService;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.community.enterprise.entity.Enterprise;
import org.springblade.community.enterprise.vo.EnterpriseVO;
import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2020-12-08
 */
public class EnterpriseWrapper extends BaseEntityWrapper<Enterprise, EnterpriseVO>  {

	private IAgencyService agencyService;
	private IResidentialService residentialService;

	public static EnterpriseWrapper build() {
		return new EnterpriseWrapper();
 	}

 	public EnterpriseWrapper(){

	}
 	public EnterpriseWrapper(IAgencyService agencyService, IResidentialService residentialService){
		this.agencyService = agencyService;
		this.residentialService = residentialService;
	}

	public static EnterpriseWrapper build(IAgencyService agencyService, IResidentialService residentialService) {
		return new EnterpriseWrapper(agencyService,residentialService);
	}

	@Override
	public EnterpriseVO entityVO(Enterprise enterprise) {
		EnterpriseVO enterpriseVO = Objects.requireNonNull(BeanUtil.copy(enterprise, EnterpriseVO.class));

		//企业所属园区名称
		if(enterprise.getAgencyId() != null){
			Agency agency = agencyService.getById(enterprise.getAgencyId());
			if(null != agency){
				enterpriseVO.setAgencyName(agency.getAgencyName());
			}
		}

		//企业所属分区名称
		if(enterprise.getResidentialId() != null){
			Residential residential = residentialService.getById(enterprise.getResidentialId());
			if(null != residential){
				enterpriseVO.setResidentialName(residential.getName());
			}
		}

		return enterpriseVO;
	}

}
